    include     \masm32\include\masm32rt.inc    ; defaults to .386

.586

    include     timers.asm      ; requires a pentium

    LOOPCOUNT equ 1000000

    PROCS TEXTEQU <Ratch,RatchX,RatchX2,StrLen1,StrLen2>

    PADSZ TEXTEQU <4,5,6,7,8,9,10,11,12,13,14,15,16>

    %FOR proc,<PROCS>
      %FOR pad,<PADSZ>
         &proc&&pad& proto :DWORD
      ENDM
    ENDM

    MAXWIDTH  equ 20
    HDRWIDTH  equ 10
    COLWIDTH  equ 5

.data

align 16

str1023 db 1023 dup ('X'),0

.code

align 16

sxFld proc DDpointer:DWORD, rvstring:DWORD, DDwidth:DWORD, DDalign:DWORD
    .if DDalign == 0
        invoke szLeft,DDpointer,rvstring,DDwidth
        invoke szLen,rvstring
        mov edx,rvstring
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+eax],32
        inc eax
        jmp @B
    @@: mov byte ptr [edx+eax],0
    .elseif DDalign == 1
        invoke szLen,DDpointer
        mov edx,rvstring
        xor ecx,ecx
    @@: cmp eax,DDwidth
        jae @F
        mov byte ptr [edx+ecx],32
        inc eax
        inc ecx
        jmp @B
    @@: add edx,ecx
        invoke szLeft,DDpointer,edx,DDwidth
    .endif
    ret 4*4

sxFld endp

fld$ MACRO DDpointer,DDwidth,DDalign:=<0>
    LOCAL rvstring
    .data
        rvstring db MAXWIDTH+4 dup (0)
        align 16
    .code
    invoke sxFld,reparg(DDpointer),ADDR rvstring,DDwidth,DDalign
    EXITM <ADDR rvstring>
ENDM

.code

align 16

start:

    print fld$(chr$("Pad nops"),HDRWIDTH)
    %FOR pad,<PADSZ>
        print fld$(ustr$(pad),COLWIDTH,1)
    ENDM
    print chr$(13,10)

    print fld$(chr$("=========="),HDRWIDTH)
    %FOR pad,<PADSZ>
        print fld$(" ====",COLWIDTH)
    ENDM
    print chr$(13,10)

    %FOR proc,<PROCS>
        print fld$(chr$("&proc&"),HDRWIDTH)
        %FOR pad,<PADSZ>
            counter_begin LOOPCOUNT, HIGH_PRIORITY_CLASS
              invoke &proc&&pad& , ADDR str1023
            counter_end
            print fld$(ustr$(eax),COLWIDTH,1)
        ENDM
        print chr$(13,10)
    ENDM
    mov   eax,input(13,10,"Press enter to exit...")
    exit

; 

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

%FOR pad,<PADSZ>

align 16

REPEAT pad
  nop
ENDM

Ratch&pad& proc junk:dword ; from Ratch           ;it all begins here
 MOV EAX,[ESP+DWORD]       ;address of string

 .REPEAT                   ;searching string ....
   MOV EDX,[EAX]           ;next 4 byte gulp (DWORD)
   ADD EAX,DWORD           ;EAX=character pointer
   LEA ECX,[EDX-01010101H] ;propagate if byte is zero
   NOT EDX                 ;set up test pattern
   AND EDX,ECX             ;leftmost bit of zero byte should now be set
   AND EDX,080808080H      ;sieve out zero bytes
 .UNTIL !ZERO?             ;check the next DWORD

                           ;we now know the current DWORD contains a zero byte
 SUB EAX,DWORD+BYTE        ;compensate for entry additions into loops

 .REPEAT                   ;searching current DWORD ...
   INC EAX                 ;increase word count if no carry from shift
   ROR EDX,8               ;bring leftmost bit of each byte into carry flag
 .UNTIL CARRY?             ;if carry flag set, byte is zero

 SUB EAX,[ESP+DWORD]       ;subtract beginning of string to get length

 RET DWORD                 ;all done, and string length in EAX

Ratch&pad& endp

align 16

REPEAT pad
  nop
ENDM

RatchX&pad& proc junk:dword      ; modified Ratch
	mov eax,[esp+4]   		;address of string
@@:		                    ;searching string ....
	mov edx,[eax]           ;next 4 byte gulp (DWORD)
	add eax,4               ;eax=character pointer to next dword to test
	lea ecx,[edx-01010101H] ;propagate if byte is zero
	not edx                 ;set up test pattern
	and edx,ecx             ;leftmost bit of zero byte should now be set
	and edx,080808080H      ;sieve out zero bytes
	jz @b  		            ;check the next DWORD
                            ;we now know the current DWORD contains a zero byte
	sub eax,4      			;compensate for entry additions into loops

@@:				           ;searching current DWORD ...
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
@@:
	sub eax,[esp+4]       ;subtract beginning of string to get length

	ret 4                 ;all done, and string length in EAX

RatchX&pad& endp

align 16

REPEAT pad
  nop
ENDM

RatchX2&pad& proc junk:dword      ; modified Ratch
	mov eax,[esp+4]   		;address of string
	nop
@@:		                    ;searching string ....
	mov edx,[eax]           ;next 4 byte gulp (DWORD)
	add eax,4               ;eax=character pointer to next dword to test
	lea ecx,[edx-01010101H] ;propagate if byte is zero
	not edx                 ;set up test pattern
	and edx,ecx             ;leftmost bit of zero byte should now be set
	and edx,080808080H      ;sieve out zero bytes
	jz @b  		            ;check the next DWORD
                            ;we now know the current DWORD contains a zero byte
	sub eax,4      			;compensate for entry additions into loops

@@:				           ;searching current DWORD ...
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
	ror edx,8              ;bring leftmost bit of each byte into carry flag
	jc @f
	add eax,1              ;increase word count if no carry from shift
@@:
	sub eax,[esp+4]       ;subtract beginning of string to get length

	ret 4                 ;all done, and string length in EAX

RatchX2&pad& endp

align 16

REPEAT pad
  nop
ENDM

StrLen1&pad& proc item:DWORD

    push    ebx

    mov     eax, [esp+2*4]          ; get pointer to string
    lea     edx, [eax+3]            ; pointer+3 used in the end
align 4
@@:
    mov     ebx, [eax]              ; read first 4 bytes
    add     eax, 4                  ; increment pointer
    lea     ecx, [ebx-01010101h]    ; subtract 1 from each byte
    not     ebx                     ; invert all bytes
    and     ecx, ebx                ; and these two
    and     ecx, 80808080h
    jz      @B                      ; no zero bytes, continue loop

    test    ecx, 00008080h          ; test first two bytes
    jnz     @F

    shr     ecx, 16                 ; not in the first 2 bytes
    add     eax, 2

@@:
    shl     cl, 1                   ; use carry flag to avoid branch
    sbb     eax, edx                ; compute length

    pop     ebx

    ret     1*4

StrLen1&pad& endp

align 16

REPEAT pad
  nop
ENDM

StrLen2&pad& proc src:DWORD

    mov     ecx, [esp+1*4]
    test    ecx, 3
    jz      @max8

@bucle:
    mov     al, [ecx]
    add     ecx, 1
    test    al, al
    jz      @lb1

    test    ecx, 3
    jnz     @bucle
align 4
@max8:
    mov     eax, [ecx]
    mov     edx, 7EFEFEFFh
    add     edx, eax
    xor     eax, 0FFFFFFFFh
    xor     eax, edx
    add     ecx, 4
    test    eax, 81010100h
    jz      @max8

    mov     eax, [ecx-4]
    test    al, al
    jz      @lb4

    test    ah, ah
    jz      @lb3

    test    eax, 0FF0000h
    jz      @lb2

    test    eax, 0FF000000h
    jnz     @max8

@lb1:
    lea     eax, [ecx-1]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb2:
    lea     eax, [ecx-2]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb3:
    lea     eax, [ecx-3]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

@lb4:
    lea     eax, [ecx-4]
    mov     ecx, [esp+1*4]
    sub     eax, ecx
    ret     1*4

StrLen2&pad& endp

ENDM

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start

